#################################################################################
# install mode.
# 
# You should not remove this file.  Alpha may not function very well
# without it.
#================================================================================

alpha::mode Inst 0.1.2 {
    # Rather than using a 'dummyProc', we use a script,
    # which is then removed (so it's only ever called once).
    hook::register openHook install::openHook Inst
    hook::register editHook install::editHook .install
    newPref v prefixString {# } Inst
    
    set Inst::commentCharacters(General)    "# "
    set Inst::commentCharacters(Paragraph)  [list "## " " ##" " # "]
    set Inst::commentCharacters(Box)        [list "#" 2 "#" 2 "#" 3]
    
    # Just a little bit of color for the comments and strings
    
    regModeKeywords -e {#} -c red -s {green} Inst {}
} [list "*Install" "*INSTALL"] {
    installMenu
} {
    addMenu installMenu "Install"
} help {
    The mode is for used by install scripts for adding additional
    packages or upgrading Alpha.  Install mode places an "Install" menu
    in the menu bar, although installation scripts generally use an
    installation dialog which provides an even better user interface.

    Click on this link "Install Example" for an example of such a
    dialog.  To see the actual script, hold down any modifier key when
    clicking on the link.

    For more information about installation, see "install.tcl".
    For more information about writing packages, see "Extending Alpha".

    This mode is not intended for text editing.
}



